package com.zeroturnaround.javarebel.guice.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

import com.google.inject.Key;

public class InjectorImplCBP extends JavassistClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
			throws Exception {
		CtConstructor[] ctrs = ctClass.getConstructors();
	    for (int i = 0; i < ctrs.length; i++) {
	      ctrs[i].insertAfter(
	          "com.google.inject.GuiceComponentReloader.registerInjector($0);");      
	    }
	    
	    CtMethod getInstanceByKeyMethod = ctClass.getDeclaredMethod("getInstance", new CtClass[] {cp.get(Key.class.getName())});
	    getInstanceByKeyMethod.setBody("{" +
	    		"try {" +
	    		"	com.google.inject.GuiceComponentReloader.setCurrentInjector($0);" +
	    		"	return getProvider($1).get();" +
	    		"} " +
	    		"finally {" +
	    		"	com.google.inject.GuiceComponentReloader.setCurrentInjector(null);" +
	    		"}" +
	    		"}");
	    
	    CtMethod getInstanceByTypeMethod = ctClass.getDeclaredMethod("getInstance", new CtClass[] {cp.get(Class.class.getName())});
	    getInstanceByTypeMethod.setBody("{" +
	    		"try {" +
	    		"	com.google.inject.GuiceComponentReloader.setCurrentInjector($0);" +
	    		"	return getProvider($1).get();" +
	    		"} " +
	    		"finally {" +
	    		"	com.google.inject.GuiceComponentReloader.setCurrentInjector(null);" +
	    		"}" +
	    		"}");	    
	}

}
